#include <fstream>
#include <algorithm>
#include <vector>

using namespace std;

int n;
int sp[2002][2002];
int tot;
vector<int> st[2002];

int main()
{
	ifstream fin("covor.in");
	ofstream fout("covor.out");

	fin >> n;
	fin.get();

	int aux;
	char arr[2005];
	for (int i = 1; i <= n; ++i)
	{
		fin.getline(arr, 2005);
		for (int j = 1; j <= n; ++j)
		{
			aux = arr[j - 1] - '0';

			if (aux == 0)
			{
				sp[i][j] = sp[i][j - 1] + 1;
				while (!st[j].empty() && sp[i][j] < sp[st[j].back()][j])
					st[j].pop_back();
				st[j].push_back(i);

				for (int k = 1; k < st[j].size(); ++k)
					tot += sp[st[j][k]][j] * (st[j][k] - st[j][k - 1]);

				tot += sp[st[j][0]][j] * st[j][0];
			}
			else
			{
				st[j].clear();
				st[j].push_back(i);
			}
		}
	}

	fout << tot;

	fin.close();
	fout.close();
}
