// Punct interior unui poligon convex
#include <fstream.h>
#include <iostream.h>
#define DIM 1000

struct Punct {
    double x, y;
};

Punct P[DIM];    
int n;

void Read();
int Interior(double x, double y); // 1 daca (x, y) e interior poligonului
ofstream fout("poligon.out");

int main()
{
    Read();
    if ( Interior(2, 2) ) 
        fout << "Interior";
    else
        fout << "Exterior";
        
    fout.close();
    return 0;
}    


void Read()
{
    ifstream fin("poligon.in");
    fin >> n;
    for ( int i = 1; i <= n; i++ )
    {
        fin >> P[i].x >> P[i].y;
    }    
     
    fin.close();
}    

int Interior(double x, double y) 
{
    P[0] = P[n];
    P[n+1] = P[1];
    for ( int i = 1; i <= n; i++ )
    {
        double a = (x - P[i-1].x) * (P[i].y - P[i-1].y) - (y - P[i-1].y) * (P[i].x - P[i-1].x);
        double b = (P[i+1].x - P[i-1].x) * (P[i].y - P[i-1].y) - (P[i+1].y - P[i-1].y) * (P[i].x - P[i-1].x);
        cout << i << " " << a << " " << b;
        cin.get();
        if ( a * b < 0 ) return 0;
    }
    return 1;
}
        
